function capitalizeFirstLetter(str)
    return str:sub(1, 1):upper() .. str:sub(2):lower()
end

function itemData(id)
    local itemName, itemLink, _, _, itemMinLevel, _, _, itemStackCount, _, iconTexture = GetItemInfo(id)

    return { ["id"] = id, ["name"] = itemName, ["link"] = itemLink, ["level"] = itemMinLevel, ["stack"] = itemStackCount, ["icon"] = iconTexture }
end

function playerStatus(playerNames)
    local flag = false

    for name in string.gmatch(playerNames, "[^\n]+") do
        if string.lower(name) == string.lower(GetUnitName("npc")) then
            flag = true
        end
    end
    return flag
end

function guildStatus(guildNames)
    local flag = false

    if GetGuildInfo("npc") then
        for guild in string.gmatch(guildNames, "[^\n]+") do
            if string.lower(guild) == string.lower(GetGuildInfo("npc")) then
                flag = true
            end
        end
    end
    return flag
end

function groupStatus()

    if IsInRaid() then
        return { ["status"] = "raid" }
    elseif IsInGroup() then
        return { ["status"] = "party" }
    else
        return { ["status"] = "solo" }
    end
end

function tradePosition()
    for i = 1, MAX_TRADABLE_ITEMS do
        if GetTradePlayerItemLink(i) == nil then
            return i
        end
    end
end