local inventoryIndex = 0
local inventory = {}
local color = "|cFF4FF4A2TradeFill:|r"

local TradeFill = LibStub("AceAddon-3.0"):GetAddon("TradeFill")

function tradeFill(item, position)
    if next(inventory) == nil then
        print(color .. " Item not found " .. item.link .. " |T" .. GetItemIcon(item.id) .. ":0|t")
        return
    end

    if position == nil then
        print(color .. " Trade window is full!|r")
        return
    else
        for i = 1, inventoryIndex do
            local locked = C_Container.GetContainerItemInfo(inventory[i].bag, inventory[i].slot)
            local stackCount = itemData(inventory[i].item)
            local stack = TradeFill.itemdb.profile.stack

            if inventory[i].bound == true then
                print(color .. " Item is Soulbound " .. item.link .. " |T" .. GetItemIcon(item.id) .. ":0|t can't trade that")
                return
            end

            if stack == false then

                if inventory[i].item == item.id and locked.isLocked == false then
                    ClearCursor()
                    C_Container.PickupContainerItem(inventory[i].bag, inventory[i].slot)
                    ClickTradeButton(position)
                    break
                end

                if i >= inventoryIndex then
                    print(color .. " Out of stock " .. item.link .. " |T" .. GetItemIcon(item.id) .. ":0|t no more stacks available")
                    return
                end
            end

            if stack == true then
                if inventory[i].item == item.id and locked.isLocked == false and inventory[i].count == stackCount.stack then
                    ClearCursor()
                    C_Container.PickupContainerItem(inventory[i].bag, inventory[i].slot)
                    ClickTradeButton(position)
                    break
                end

                if i >= inventoryIndex then
                    print(color .. " Out of stock " .. item.link .. " |T" .. GetItemIcon(item.id) .. ":0|t no more full stack available")
                    return
                end
            end
        end
    end
end

function start()
    local itemA = itemData(TradeFill.itemdb.profile.itemIdA)
    local itemB = itemData(TradeFill.itemdb.profile.itemIdB)
    local guild = TradeFill.itemdb.profile.guild
    local level = TradeFill.itemdb.profile.level

    local _, ClassName, _ = UnitClass("npc")
    local guildName = GetGuildInfo("npc")

    local stackA = TradeFill.stacksdb.profile[ClassName].stackNumberA
    local stackB = TradeFill.stacksdb.profile[ClassName].stackNumberB

    for bag = 0, 4 do
        for slot = 1, C_Container.GetContainerNumSlots(bag) do
            local bagItem = C_Container.GetContainerItemInfo(bag, slot)

            if bagItem ~= nil then
                if bagItem.itemID == itemA.id or bagItem.itemID == itemB.id then
                    inventoryIndex = inventoryIndex + 1
                    inventory[inventoryIndex] = {
                        ["bag"] = bag,
                        ["slot"] = slot,
                        ["item"] = bagItem.itemID,
                        ["bound"] = bagItem.isBound,
                        ["count"] = bagItem.stackCount,
                        ["link"] = bagItem.hyperlink
                    }
                end
            end
        end
    end

    local players = TradeFill.itemdb.profile.players

    if playerStatus(players) then
        print(color .. " Don't autoFill trade window with |cFF00FF00<".. UnitName("npc") .. ">|r this player is on the exclude list")
        return
    end

    local guilds = TradeFill.itemdb.profile.guilds

    if guildStatus(guilds) then
        print(color .. " Don't autoFill trade window with |cFF00FF00<".. guildName .. ">|r this guild is on the exclude list")
        return
    end

    if stackA == 0 and stackB == 0 then
        print(color .. " Can't autoFill trade window with class |cFF00FF00<".. capitalizeFirstLetter(ClassName) .. ">|r no stack number have been assigned")
        return
    end

    local group = groupStatus()

    local stranger = TradeFill.itemdb.profile.solo
    local party = TradeFill.itemdb.profile.party
    local raid = TradeFill.itemdb.profile.raid

    if (party == true and group.status == "party") or (raid == true and group.status == "raid") then
        local numGroupMembers = GetNumGroupMembers()

        if numGroupMembers > 0 then
            for i = 1, numGroupMembers do
                local unitName = UnitName(group.status .. i)

                if unitName == UnitName("npc") then

                    if itemA.id > 0  then
                        if level == true and  UnitLevel("npc") < itemA.level then
                            print(color .. " Don't autoFill trade window with " .. itemA.link .. " |T" .. GetItemIcon(itemA.id) .. ":0|t not the required level")
                        elseif guild == true and guildName ~= GetGuildInfo("player") and GetGuildInfo("npc") ~= nil then
                            print(color .. " Don't autoFill trade window with |cFF00FF00<".. GetGuildInfo("npc") .. ">|r this not a guild member")
                            return
                        else
                            for i = 1, stackA do
                                tradeFill(itemA, tradePosition())
                            end
                        end
                    end

                    if itemB.id > 0 then
                        if level == true and  UnitLevel("npc") < itemB.level then
                            print(color .. " Don't autoFill trade window with " .. itemB.link .. " |T" .. GetItemIcon(itemB.id) .. ":0|t not the required level")
                        elseif guild == true and guildName ~= GetGuildInfo("player") and GetGuildInfo("npc") ~= nil then
                            print(color .. " Don't autoFill trade window with |cFF00FF00<".. GetGuildInfo("npc") .. ">|r this not a guild member")
                            return
                        else
                            for i = 1, stackB do
                                tradeFill(itemB, tradePosition())
                            end
                        end
                    end
                    break
                end
            end
        return
        end
    end

    if stranger == true and group.status == "solo" then

        if itemA.id > 0  then
            if level == true and  UnitLevel("npc") < itemA.level then
                print(color .. " Don't autoFill trade window with " .. itemA.link .. " |T" .. GetItemIcon(itemA.id) .. ":0|t not the required level")
            elseif guild == true and guildName ~= GetGuildInfo("player") and GetGuildInfo("npc") ~= nil then
                print(color .. " Don't autoFill trade window with |cFF00FF00<".. GetGuildInfo("npc") .. ">|r this not a guild member")
                return
            else
                for i = 1, stackA do
                    tradeFill(itemA, tradePosition())
                end
            end
        end

        if itemB.id > 0 then
            if level == true and  UnitLevel("npc") < itemB.level then
                print(color .. " Don't autoFill trade window with " .. itemB.link .. " |T" .. GetItemIcon(itemB.id) .. ":0|t not the required level")
            elseif guild == true and guildName ~= GetGuildInfo("player") and GetGuildInfo("npc") ~= nil then
                print(color .. " Don't autoFill trade window with |cFF00FF00<".. GetGuildInfo("npc") .. ">|r this not a guild member")
                return
            else
                for i = 1, stackB do
                    tradeFill(itemB, tradePosition())
                end
            end
        end
    end
end

function close()
    inventoryIndex = 0
    inventory = {}
end

TradeFill:RegisterEvent("TRADE_SHOW", start)
TradeFill:RegisterEvent("TRADE_CLOSED", close)